summaryrefslogtreecommitdiffstats
path: root/contrib
diff options
context:
space:
mode:
authorEric Bélanger <snowmaniscool@gmail.com>2011-11-21 23:21:24 +0100
committerDan McGee <dan@archlinux.org>2011-12-12 19:48:50 +0100
commitb75fac5be31d6056e78fd29a0548cc3e6275a1b8 (patch)
treeacb6406afd20db23b2637bc8946fb68638551f68 /contrib
parent6a1d3948a670184f01a697efe55b91b4ccdcb51d (diff)
downloadpacman-b75fac5be31d6056e78fd29a0548cc3e6275a1b8.tar.gz
pacman-b75fac5be31d6056e78fd29a0548cc3e6275a1b8.tar.xz
pacsysclean: Add new contrib script
pacsysclean sort installed packages by decreasing installed size. It's useful for finding large unused package when doing system clean-up. This script is an improved version of other similar scripts posted on the forums. Thanks goes to Dan for fixing and improving my original script. Signed-off-by: Eric Bélanger <snowmaniscool@gmail.com> Signed-off-by: Dan McGee <dan@archlinux.org>
Diffstat (limited to 'contrib')
-rw-r--r--contrib/.gitignore1
-rw-r--r--contrib/Makefile.am5
-rwxr-xr-xcontrib/pacsysclean.in50
3 files changed, 55 insertions, 1 deletions
diff --git a/contrib/.gitignore b/contrib/.gitignore
index 1bd145fc..19b81e00 100644
--- a/contrib/.gitignore
+++ b/contrib/.gitignore
@@ -6,5 +6,6 @@ paclist
paclog-pkglist
pacscripts
pacsearch
+pacsysclean
wget-xdelta.sh
zsh_completion
diff --git a/contrib/Makefile.am b/contrib/Makefile.am
index be0a4ba3..0ff1d9db 100644
--- a/contrib/Makefile.am
+++ b/contrib/Makefile.am
@@ -5,7 +5,8 @@ OURSCRIPTS = \
paclist \
paclog-pkglist \
pacscripts \
- pacsearch
+ pacsearch \
+ pacsysclean
OURFILES = \
bash_completion \
@@ -21,6 +22,7 @@ EXTRA_DIST = \
paclist.in \
pacscripts.in \
pacsearch.in \
+ pacsysclean.in \
vimprojects \
zsh_completion.in \
README
@@ -59,6 +61,7 @@ paclist: $(srcdir)/paclist.in
paclog-pkglist: $(srcdir)/paclog-pkglist.in
pacscripts: $(srcdir)/pacscripts.in
pacsearch: $(srcdir)/pacsearch.in
+pacsysclean: $(srcdir)/pacsysclean.in
pactree: $(srcdir)/pactree.in
zsh_completion: $(srcdir)/zsh_completion.in
diff --git a/contrib/pacsysclean.in b/contrib/pacsysclean.in
new file mode 100755
index 00000000..c87082e0
--- /dev/null
+++ b/contrib/pacsysclean.in
@@ -0,0 +1,50 @@
+#!/bin/bash
+
+# pacsysclean - Sort installed packages by decreasing installed size. Useful for system clean-up.
+
+PACMAN_OPTS=
+
+usage() {
+ echo "pacsysclean - Sort installed packages by decreasing installed size."
+ echo
+ echo "Usage: pacsysclean [options]"
+ echo
+ echo "Options:"
+ echo " -o <options> Specify custom pacman query options (e.g., dt)"
+ echo " -h, --help Show this help message and exit"
+}
+
+
+if [ -n "$1" ]; then
+ case "$1" in
+ -o) PACMAN_OPTS="${2}" ;;
+ -h|--help) usage; exit 0 ;;
+ *) usage; exit 1 ;;
+ esac
+fi
+
+IFS=$'\n'
+name="^Name.*: (.*)$"
+size="^Installed Size.*: (.*) KiB$"
+for line in $(LANG=C pacman -Qi $PACMAN_OPTS); do
+ if [[ $line =~ $name ]]; then
+ printf "%s\t" ${BASH_REMATCH[1]}
+ elif [[ $line =~ $size ]]; then
+ printf "%s\n" ${BASH_REMATCH[1]}
+ fi
+done | sort -g -k2 | awk '
+BEGIN {
+ split("KiB MiB GiB TiB PiB EiB ZiB YiB", suffix)
+}
+function format_size(size) {
+ count = 1
+ while (size + 0 > 1024) {
+ size /= 1024
+ count++
+ }
+ sizestr = sprintf("%.2f %s", size, suffix[count])
+ return sizestr
+}
+{
+ printf("%s\t%s\n", format_size($2), $1);
+}'